/*
 * ProertiesTable.java
 *
 * Created on June 24, 2007, 12:26 PM
 *
 * ProertiesTable is to:
 *
 *  explain here, what this class does...
 *
 * Admin is a Tool around JDBC-enabled SQL-Databases to do basic jobs
 * for DB-Administrations, as create / delete / alter and query tables
 * it also creates indices and generates simple Java-Code to access DBMS-tables
 * and exports data into various formats
 *
 *
 *   Copyright (C)     2003, Fredy Fischer
 *                           sql@hulmen.ch
 *   Postal: Fredy Fischer
 *           Hulmenweg 36
 *           8405 Winterthur
 *           Switzerland
 *
 *   This library is free software; you can redistribute it and/or
 *   modify it under the terms of the GNU Lesser General Public
 *   License as published by the Free Software Foundation; either
 *   version 2.1 of the License, or any later version.
 *
 *   This library is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *   Lesser General Public License for more details.
 *
 *   You should have received a copy of the GNU Lesser General Public
 *   License along with this library; if not, write to the Free Software
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 
 */

package gpl.fredy.test;

import javax.swing.JTable;
import javax.swing.table.*;
import java.util.Vector;
import java.util.Properties;
import java.util.Enumeration;

/**
 *
 * @author afs
 */
public class PropertiesTable extends AbstractTableModel  {
    
    
    public String[] columnNames = { "Property", "Value"    };
    
    Vector data;
    
    public void clearData() {
        data.removeAllElements();
        fireTableDataChanged();
    }
    
    
    public void addRow(Vector v) {
        
        data.addElement(v);
        fireTableChanged(null);
    }
    
    public void removeRow(int row) {
        data.removeElementAt(row);
        fireTableChanged(null);
    }
    
    public String getColumnName(int i) {
        
        return columnNames[i];
    }
    
    public int getColumnCount() { return columnNames.length; }
    
    public int getRowCount() { return data.size(); }
    
    public Object getValueAt(int row, int col) {
        Vector rowData = (Vector)data.elementAt(row);
        return rowData.elementAt(col);
    }
    
    public boolean isCellEditable(int row, int col) {
        boolean b = false;
        return b;
    }
    
    public void setValueAt(Object value, int row, int col) {
        
    }
    
    
    
    /** Creates a new instance of ProertiesTable */
    public PropertiesTable() {
        
        data = new Vector();
        
        Properties props = System.getProperties();
        
        Enumeration e = props.propertyNames();
        for (; e.hasMoreElements(); ) {
            String propName = (String)e.nextElement();
            String propValue = (String)props.get(propName);
            Vector v = new Vector();
            v.addElement(propName);
            v.addElement(propValue);
            addRow(v);
        }
        
    }
}