package gpl.fredy.webmail;

import java.util.Properties;
import java.util.StringTokenizer;
import java.util.Vector;
import javax.mail.*;
import javax.mail.internet.*;
import java.io.*;

public class ReplyMessage {


    String address;
    
    /**
     * Get the value of address.
     * @return value of address.
     */
    public String getAddress() {
	return address;
    }
    
    /**
     * Set the value of address.
     * @param v  Value to assign to address.
     */
    public void setAddress(String  v) {
	this.address = v;
    }
    

    MimeMessage message;
    
    /**
     * Get the value of message.
     * @return value of message.
     */
    public MimeMessage getMessage() {
	return message;
    }
    
    /**
     * Set the value of message.
     * @param v  Value to assign to message.
     */
    public void setMessage(MimeMessage  v) {
	this.message = v;
    }
    

    public ReplyMessage() {
	
    }

    public ReplyMessage(MimeMessage message) {
	this.setMessage(message);
    }
    
     public ReplyMessage(String address,MimeMessage message) {
	this.setMessage(message);
	this.setAddress(address);
       
    }

    public boolean reply(boolean all,
			 boolean include, 
			 String text) {
		

	/**
	 * to reply we do as follows:
	 * 1) we create a reply-Message
         * 2) we put our address into the reply-part
         * 3) we modify the text
	 *
	 * needed parameters:
         * - the message
         * - a text
         * - my E-Mail-Address
	 **/
        boolean success = true;
	try {
	    MimeMessage reply = (MimeMessage)getMessage().reply(all);
	    reply.setFrom(new InternetAddress(getAddress()));
	    
	    if (include ) {
		StringBuffer buffer = new StringBuffer(text + "\n\n");
		if (getMessage().isMimeType("text/plain")) {
		    String content = (String)getMessage().getContent();
		    StringReader contentReader = new StringReader(content);
		    BufferedReader br = new BufferedReader(contentReader);
		    String contentLine;
		    while ((contentLine = br.readLine()) != null) {
			buffer.append("> ");
			buffer.append(contentLine);
			buffer.append("\r\n");
		    }
		    reply.setText(buffer.toString());
		}            
	    } else {
		reply.setText(text);	
	    } 
	    Transport.send(reply);
	} catch ( Exception e) {
	    success = false; 
	    setError(e.getMessage().toString());
	}
	return success;
    }

    String error=null;
    
    /**
     * Get the value of error.
     * @return value of error.
     */
    public String getError() {
	return error;
    }
    
    /**
     * Set the value of error.
     * @param v  Value to assign to error.
     */
    public void setError(String  v) {
	this.error = v;
    }
    
}
